"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.bootstrappedAtom = void 0;
const recoil_1 = require("recoil");
function bootstrappedAtom(rootAtom, _a) {
    var { initialValue, key } = _a, options = __rest(_a, ["initialValue", "key"]);
    if ('default' in options) {
        throw new Error('The "default" prop is not allowed in bootstrapped atoms. Use "initialValue" instead');
    }
    return (0, recoil_1.atom)(Object.assign(Object.assign({}, options), { key, 
        // We set the default to a selector so that we can grab the bootstrap data
        // from the rootAtom, which is set in a BootstrapRoot component
        default: (0, recoil_1.selector)({
            key: `${key}:atomInitializer`,
            get: ({ get }) => initialValue(get(rootAtom)),
        }) }));
}
exports.bootstrappedAtom = bootstrappedAtom;
//# sourceMappingURL=bootstrappedAtom.js.map