// Tell React that this is not a server component, since it's likely to be used
// as the first client-side component in a tree
'use client';
import React, { useEffect } from 'react';
import { useRecoilStateLoadable } from 'recoil';
export function BootstrapRoot({ children, bootstrapData, rootAtom, }) {
    const [bootstrapDataLoadable, setBootstrapData] = useRecoilStateLoadable(rootAtom);
    // We only want to initialize once, even if bootstrap data changes. If
    // bootstrap data changes, it's a bug in the calling code
    // eslint-disable-next-line react-hooks/exhaustive-deps
    useEffect(() => setBootstrapData(bootstrapData), []);
    switch (bootstrapDataLoadable.state) {
        case 'loading': {
            return null;
        }
        case 'hasError': {
            throw bootstrapDataLoadable.contents;
        }
        case 'hasValue': {
            return React.createElement(React.Fragment, null, children);
        }
    }
}
//# sourceMappingURL=bootstrapRoot.js.map